--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Cooking skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "COOM"
local COOM, prevCOOM = 0.0, -2
local COOMmax, prevCOOMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["cooking"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();

	if cooking ~= nil then
		local name, _, skillLevel, maxSkillLevel, _, _, _, _ = GetProfessionInfo(cooking)
		COOM = skillLevel
		COOMmax = maxSkillLevel
		if not startskill then startskill = skillLevel end

		if COOM == prevCOOM and prevCOOMmax == COOMmax then
			return
		end

		prevCOOMmax = COOMmax
		prevCOOM  = COOM

		TitanPanelButton_UpdateButton(id)
		return true
	end
end
-----------------------------------------------
local function GetButtonText(self, id)
	local COOMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..COOMmax
	end

	local BarBalanceText = ""
	if COOMmax ~= 0 and (COOM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(COOM - startskill).."]"
	end

	if COOM == 700 then
		COOMtext = "|cFF69FF69"..L["maximum"]
	elseif COOMmax == 0 then
		COOMtext = "|cFFFF2e2e"..L["noprof"]
	elseif COOM == COOMmax then
		COOMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		COOMtext = "|cFFFFFFFF"..COOM..HideText..BarBalanceText
	end

	return L["cooking"]..": ", COOMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if COOMmax == 0 then
		ColorValueAccount = ""
	elseif COOM == 700 then
		ColorValueAccount = ""
	elseif (COOM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (COOM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(COOM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if COOM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["cooking"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFF05a7ab "..L["cooking"].."|r".." Multi",
	tooltip = L["cooking"],
	icon = "Interface\\Icons\\Inv_misc_food_15.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
