--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Enchanting skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "ENCM"
local ENCM, prevENCM = 0.0, -2
local ENCMmax, preENCMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["enchanting"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2 = GetProfessions();

	local skillLevel = 0
	local maxSkillLevel = 0

	if prof1 then
		local name, _, level, maxLevel = GetProfessionInfo(prof1)
		if name == L["enchanting"] then
			skillLevel = level
			maxSkillLevel = maxLevel
		elseif prof2 then
			name, _, level, maxLevel = GetProfessionInfo(prof2)
			if name == L["enchanting"] then
				skillLevel = level
				maxSkillLevel = maxLevel
			end
		end
	end

	ENCM = skillLevel
	ENCMmax = maxSkillLevel
	if not startskill then startskill = skillLevel end

	if ENCM == prevENCM and ENCMmax == preENCMmax then
		return
	end

	preENCMmax = ENCMmax
	prevENCM = ENCM

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local ENCMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..ENCMmax
	end

	local BarBalanceText = ""
	if ENCMmax ~= 0 and (ENCM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(ENCM - startskill).."]"
	end

	if ENCM == 700 then
		ENCMtext = "|cFF69FF69"..L["maximum"]
	elseif ENCMmax == 0 then
		ENCMtext = "|cFFFF2e2e"..L["noprof"]
	elseif ENCM == ENCMmax then
		ENCMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		ENCMtext = "|cFFFFFFFF"..ENCM..HideText..BarBalanceText
	end

	return L["enchanting"]..": ", ENCMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if not ENCM then
		ColorValueAccount = ""
	elseif ENCM == 700 then
		ColorValueAccount = ""
	elseif (ENCM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (ENCM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(ENCM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if ENCM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["enchanting"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFccce00 "..L["enchanting"].."|r".." Multi",
	tooltip = L["enchanting"],
	icon = "Interface\\Icons\\Trade_engraving.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
