--[[
Description: This plugin is part of the "Titan Panel [Professions] Multi" addon. It shows your Tailoring skill level.
Site: http://www.curse.com/addons/wow/titan-panel-professions-multi
Author: Canettieri
Special Thanks to Eliote.
--]]

local ADDON_NAME, L = ...;
local version = GetAddOnMetadata(ADDON_NAME, "Version")
local ID = "TAIM"
local TAIM, prevTAIM = 0.0, -2
local TAIMmax, preTAIMmax = 0, 0
local startskill
-----------------------------------------------
local function OnClick(self, button)
	if (button == "LeftButton") then
		local prof = L["tailoring"]
		CastSpellByName(prof)
	end
end
-----------------------------------------------
local function OnUpdate(self, id)
	local prof1, prof2 = GetProfessions();

	local skillLevel = 0
	local maxSkillLevel = 0

	if prof1 then
		local name, _, level, maxLevel = GetProfessionInfo(prof1)
		if name == L["tailoring"] then
			skillLevel = level
			maxSkillLevel = maxLevel
		elseif prof2 then
			name, _, level, maxLevel = GetProfessionInfo(prof2)
			if name == L["tailoring"] then
				skillLevel = level
				maxSkillLevel = maxLevel
			end
		end
	end

	TAIM = skillLevel
	TAIMmax = maxSkillLevel
	if not startskill then startskill = skillLevel end

	if TAIM == prevTAIM and TAIMmax == preTAIMmax then
		return
	end

	preTAIMmax = TAIMmax
	prevTAIM = TAIM

	TitanPanelButton_UpdateButton(id)
	return true
end
-----------------------------------------------
local function GetButtonText(self, id)
	local TAIMtext
	local HideText = "" -- Texto HideMax
	if not TitanGetVar(ID, "HideMax") then
		HideText = "|r/|cFFFF2e2e"..TAIMmax
	end

	local BarBalanceText = ""
	if TAIMmax ~= 0 and (TAIM - startskill) > 0 and TitanGetVar(ID, "ShowBarBalance") then
		BarBalanceText = " |cFF69FF69["..(TAIM - startskill).."]"
	end

	if TAIM == 700 then
		TAIMtext = "|cFF69FF69"..L["maximum"]
	elseif TAIMmax == 0 then
		TAIMtext = "|cFFFF2e2e"..L["noprof"]
	elseif TAIM == TAIMmax then
		TAIMtext = "|cFFB4EEB4"..L["gotrainer"]
	else
		TAIMtext = "|cFFFFFFFF"..TAIM..HideText..BarBalanceText
	end

	return L["tailoring"]..": ", TAIMtext
end
-----------------------------------------------
local function GetTooltipText(self, id)
	local ColorValueAccount -- Cores da conta de valor
	if not TAIM then
		ColorValueAccount = ""
	elseif TAIM == 700 then
		ColorValueAccount = ""
	elseif (TAIM - startskill) == 0 then
		ColorValueAccount = "\r"..L["session"]..TitanUtils_GetHighlightText("0")
	elseif (TAIM - startskill) > 0 then
		ColorValueAccount = "\r"..L["session"].."|cFF69FF69"..(TAIM - startskill)
	end

	local ValueText = "" -- Difere com e sem profissão
	if TAIM == 0 then
		ValueText = L["noskill"]
	else
		ValueText = L["tooltipDescription"]..L["tailoring"].."."..ColorValueAccount
	end

	return ValueText
end
-----------------------------------------------
L.Elib({
	id = ID,
	name = "Titan|cFFccce00 "..L["tailoring"].."|r".." Multi",
	tooltip = L["tailoring"],
	icon = "Interface\\Icons\\Trade_tailoring.blp",
	category = "Profession",
	version = version,
	onUpdate = OnUpdate,
	onClick = OnClick,
	getButtonText = GetButtonText,
	getTooltipText = GetTooltipText,
	prepareMenu = L.PrepareProfessionsMenu,
	savedVariables = {
		ShowIcon = 1,
		DisplayOnRightSide = false,
		HideMax = false,
		ShowBarBalance = false,
		ShowLabelText = false,
	}
})
